---
name: Bug report
about: Create a report to help us improve
title: "[BUG] "
labels: ''
assignees: ''

---

**Description**

<!-- a general description goes here -->

**Code**

<!-- a snippet of code that demonstrates the issue -->

**Expected Behavior**

<!-- a general description of what was the expected behavior or result -->

**Actual Behavior**

<!-- a general description of what really happened -->

**Basic Information**

- Version with issue:  <!-- the version of SkiaSharp that has the issue -->
- Last known good version:  <!-- the version of SkiaSharp that still working -->
- IDE:  <!-- Visual Studio / Visual Studio for Mac / MonoDevelop / Visual Studio Code -->
- Platform Target Frameworks: <!-- all that apply, remove the platforms that aren't broken or haven't had any testing -->
  - Android: <!-- the version of the Android SDK you are compiling against, e.g. 7.1 --> 
  - iOS:  <!-- the version of the iOS SDK you are compiling against, e.g. 11.1 -->
  - Linux:  <!-- The version and distro of linux that you are building for, e.g. Ubuntu 16.04 -->
  - macOS:  <!-- The version of macOS you are building for, e.g. 10.10 -->
  - Tizen:  <!-- the version of the Tizen SDK you are compiling against, e.g. 4.0 --> 
  - tvOS:  <!-- the version of the tvOS SDK you are compiling against, e.g. 11.1 -->
  - UWP:  <!-- the version of the UWP SDK you are compiling against, e.g. 16299 --> 
  - watchOS:  <!-- the version of the watchOS SDK you are compiling against, e.g. 11.1 -->
  - Windows Classic:  <!-- the version of Windows you are building for, e.g. Windows 7 -->
- Target Devices:   <!-- the devices that you noticed this on, e.g. iPhone X -->
  - <!-- Google Pixel 4 XL -->
  - <!-- iPhone 11 -->
  
<details>
  <summary>Detailed IDE/OS information (click to expand)</summary>
  
```

PASTE ANY DETAILED VERSION INFO HERE

```
</details>


**Screenshots**

<!-- if the issue is a visual issue, please include screenshots showing the problem if possible -->

**Reproduction Link**

<!-- please upload or provide a link to a reproduction case -->

